## emacs24 24.5+1

=== test/indent/Makefile ===
RM=rm
EMACS=emacs

clean:
	-$(RM) *.test

# TODO:
# - mark the places where the indentation is known to be incorrect,
#   and allow either ignoring those errors or not.
%.test: %
	-$(RM) $<.new
	$(EMACS) --batch $< \
	    --eval '(indent-region (point-min) (point-max) nil)' \
	    --eval '(write-region (point-min) (point-max) "$<.new")'
	diff -u -B $< $<.new

=== test/automated/flymake/warnpred/Makefile ===
# Makefile for flymake tests

CC_OPTS = -Wall

check-syntax:
	$(CC) $(CC_OPTS) ${CHK_SOURCES}

# eof

=== debian/changelog ===
emacs24 (24.5+1-8ubuntu2) zesty; urgency=medium

  * d/p/0024-Emacs-should-no-longer-hang-when-loading-TRAMP.patch: Backport
    patch from the emacs-25 branch to turn off address randomisation on
    ppc64el, to fix build failure (& would-be failure loading some files at
    runtime too)

 -- Iain Lane <iain@orangesquash.org.uk>  Fri, 10 Feb 2017 12:54:23 +0000

emacs24 (24.5+1-8ubuntu1) zesty; urgency=medium

  * Merge with Debian; remaining changes:
    - debian/rules: Make sure the emacs24-el directory exists.
    - emacsVER-lp725988.patch: Set the X EMACS_CLASS to "Emacs24" to
      please bamf and gnome-shell.
    - debian/emacsVER.desktop: Also set StartupWMClass for bamf and
      gnome-shell.
    - debian/control.in: Have emacs24-common Depends on
      emacs24-common-non-dfsg, now that it is out of multiverse.
      Update debian/copyright to match.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 23 Jan 2017 15:03:13 +0100

emacs24 (24.5+1-8) unstable; urgency=medium

  * Configure with REL_ALLOC=no to fix crashes.  Thanks to Santiago
    Vila for reporting the problem, and Sean Whitton for helping test
    the fix. (Closes: 849775)

  * Backport upstream fix for TRAMP hang on startup.  Thanks to Sean
    Whitton for tracking down, backporting and testing the
    fix. (Closes: 810640)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 22 Jan 2017 14:32:37 -0600

emacs24 (24.5+1-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable building with PIE which is now the default (Closes: #837421)
  * Add Breaks: oneliner-el (<= 0.3.6-7.1) (Closes: #754892)

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 18 Dec 2016 16:07:54 +0100

emacs24 (24.5+1-7ubuntu2) zesty; urgency=medium

  * Rebuild against new imagemagick 6.9.7.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Jan 2017 13:17:02 +0100

emacs24 (24.5+1-7ubuntu1) yakkety; urgency=medium

  * Merge with Debian; remaining changes:
    - debian/rules: Make sure the emacs24-el directory exists.
    - emacsVER-lp725988.patch: Set the X EMACS_CLASS to "Emacs24" to
      please bamf and gnome-shell.
    - debian/emacsVER.desktop: Also set StartupWMClass for bamf and
      gnome-shell.
    - debian/control.in: Have emacs24-common Depends on
      emacs24-common-non-dfsg, now that it is out of multiverse.
      Update debian/copyright to match.
    - Add -no-pie on amd64, ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Sep 2016 12:44:25 +0200

emacs24 (24.5+1-7) unstable; urgency=medium

  * debian/control: make Source-Version source:Version.  Thanks to
    Guillem Jover for reporting the problem. (Closes: 833215)

  * Restore GTK+ toolbar icons.
    Add 0020-Emacs-should-show-GTK-icons-again.patch to include the relevant
    upstream code.  Thanks to Juerg Haefliger for reporting the problem and
    pointing out the relevant upstream commit. (Closes: 828000)

  * Fix malloc handling with newer gcc (>= 5.2).
    Add 0021-Emacs-should-work-with-gcc-5.2-and-newer.patch to incorporate
    the relevant upstream code.  Thanks to Aurelien Jarno for reporting the
    problem and backporting the fix.

  * Support glibc 2.24.
    Add 0022-Emacs-should-work-with-glibc-2.24-on-ppc64.patch to incorporate
    the relevant upstream code. Thanks to Aurelien Jarno for reporting the
    problem and backporting the fix. (Closes: 833727)

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 05 Sep 2016 15:05:00 -0500

emacs24 (24.5+1-6ubuntu3) yakkety; urgency=medium

  * Add -no-pie on amd64 and ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 25 Apr 2016 15:29:54 +0200

emacs24 (24.5+1-6ubuntu2) yakkety; urgency=medium

  * No-change rebuild for libpng soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 00:04:03 +0000

=== debian/control ===
Source: emacs24
Section: editors
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Rob Browning <rlb@defaultvalue.org>
Build-Depends: bsd-mailx | mailx, libncurses5-dev, texinfo, liblockfile-dev, librsvg2-dev,
 libgif-dev | libungif4-dev,
 libtiff-dev,
 xaw3dg-dev,
 libpng-dev, libjpeg-dev, libm17n-dev, libotf-dev,
 libgpm-dev [linux-any], libdbus-1-dev,
 autoconf, automake, autotools-dev, dpkg-dev (>> 1.10.0), quilt (>= 0.42),
 debhelper (>= 9), libxaw7-dev, sharutils, imagemagick, libgtk-3-dev,
 libgnutls28-dev, libxml2-dev, libselinux1-dev [linux-any], libmagick++-dev,
 libgconf2-dev, libasound2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
 libacl1-dev,
 zlib1g-dev
Homepage: http://www.gnu.org/software/emacs/
Standards-Version: 3.7.2

Package: emacs24-lucid
Architecture: any
Depends: emacs24-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: emacs24, emacsen, editor, info-browser, mail-reader, news-reader
Conflicts: emacs24, emacs24-nox
Replaces: emacs24, emacs24-nox
Description: GNU Emacs editor (with Lucid GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with support for a graphical user
 interface based on the Lucid toolkit (instead of the GTK+ interface
 provided by the emacs24 package).  Until some known GTK+
 problems are fixed, this version may help avoid crashing Emacs during
 an emacsclient disconnect.  See
 https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=567934 and
 https://bugzilla.gnome.org/show_bug.cgi?id=85715 for more
 information.

Package: emacs24-lucid-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs24-lucid-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs24-lucid
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs24-lucid
 package.

Package: emacs24-nox
Architecture: any
Depends: emacs24-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: emacs24, editor, emacsen, info-browser, mail-reader, news-reader
Conflicts: emacs24, emacs24-lucid
Replaces: emacs24, emacs24-lucid
Description: GNU Emacs editor (without GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs compiled without support for X,
 and provides only a text terminal interface.

Package: emacs24-nox-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs24-nox-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs24-nox
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs24-nox
 package.

Package: emacs24
Architecture: any
Depends: emacs24-bin-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: editor, emacsen, info-browser, mail-reader, news-reader
Conflicts: emacs24-lucid, emacs24-nox
Replaces: emacs24-lucid, emacs24-nox
Description: GNU Emacs editor (with GTK+ GUI support)
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains a version of Emacs with a graphical user interface
 based on GTK+ (instead of the Lucid toolkit provided by the
 emacs24-lucid package).

Package: emacs24-dbg
Section: debug
Priority: extra
Architecture: any
Depends: emacs24-dbg (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for emacs24
 GNU Emacs is the extensible self-documenting text editor.  This
 package contains the debugging symbols for the emacs24 package.

Package: emacs24-bin-common
Architecture: any
Depends: emacs24-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: GNU Emacs editor's shared, architecture dependent files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture dependent infrastructure
 that's shared by emacs24, emacs24-lucid, and emacs24-nox.

Package: emacs24-common
Architecture: all
Depends: emacsen-common (>= 2.0.8), dpkg (>= 1.15.4) | install-info, ${shlibs:Depends}, ${misc:Depends}, emacs24-common-non-dfsg
Recommends: emacs24-el
Suggests: emacs24-el, ncurses-term
Conflicts: emacs24-el (<< ${source:Version}), cedet, eieio, speedbar, gnus-bonus-el
Breaks: apel (<< 10.8+0.20120427-4),
        oneliner-el (<= 0.3.6-7.1)
Description: GNU Emacs editor's shared, architecture independent infrastructure
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the architecture independent infrastructure
 that's shared by emacs24, emacs24-lucid, and emacs24-nox.

Package: emacs24-el
Architecture: all
Depends: emacs24-common (= ${source:Version}), ${misc:Depends}
Description: GNU Emacs LISP (.el) files
 GNU Emacs is the extensible self-documenting text editor.
 This package contains the elisp sources for the convenience of users,
 saving space in the main package for small systems.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This file is licensed under the terms of the Gnu Public License.
# With the one additional provision that Ian Jackson's name may not be
# removed from the file.

# Copyright 1994,1995 Ian Jackson
# Copyright 2004-2005 Jrme Marant <jerome@debian.org>
# Copyright 1998-2015 Rob Browning <rlb@defaultvalue.org>

# Originally copied from the GNU Hello Debian rules file (1.3).
# Modified for emacs by Mark Eichin <eichin@kitten.gen.ma.us>.
# Debhelper support added via one of Joey Hess' example files.
# See the debian/changelog for further historical information.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SHELL := /bin/bash
quilt := QUILT_PATCHES=debian/patches QUILT_PATCHES_PREFIX=y quilt
pf := set -o pipefail

# This package uses debian/source/format 3.0 (quilt).

# For now we assume that emacs' versioning scheme is always
# MAJOR.MINORtinyrev where MAJOR and MINOR are integers and tinyrev is
# an optional lowercase letter (or letters).  We also assume that
# upstream uses a numbering scheme that sorts in a "Debian friendly"
# way.  So far that's always been true.  If it becomes false, some of
# the values below will have to be set manually.

# (You might imagine that a VPATH build would allow us to avoid having
#  to copy the entire source tree for each of the three builds, but it
#  turns out that without additional complexity, VPATH builds will
#  cause diff bloat.  That's because the emacs build process doesn't
#  completely respect the .elc files; some are modified in srcdir, not
#  builddir.)

# The official upstream version defined by AC_INIT in configure.in.
upstream_ver := $(shell debian/upstream-version)
ifeq (,$(upstream_ver))
  $(error 'Unable to find upstream version number.')
endif

# This must be the version that's actually used at runtime for things
# like load-path.  It may not be the same as the upstream version
# (i.e. when you have upstream 20.5a, the functional version may still
# be 20.5), so sometimes we may have to do this by hand.
runtime_ver := $(shell $(pf); echo $(upstream_ver) | perl -pe 's/[a-z]+$$//o')
major_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/\..*$$//o')
minor_ver := $(shell $(pf); echo $(runtime_ver) | perl -pe 's/^[^.]*\.//o')

# The name of the Debian source package
src_name := $(shell $(pf); dpkg-parsechangelog | egrep '^Source:')
src_name := $(shell $(pf); echo $(src_name) | perl -pe 's/Source:\s+//o')

# The version from the changelog (i.e. 20.5-1)
debian_ver := $(shell $(pf); dpkg-parsechangelog | egrep '^Version:')
debian_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/Version:\s+//o')

# The Debian revision (i.e. the 1 from 20.5-1)
# Always everything after the last '-'
debian_rev := $(shell $(pf); echo $(debian_ver) | perl -pe 's/.*-//o')

# Might be 21.3, or it might be 21.3+1 if we've had to have more than
# one re-release of the upstream source (rare, but it happens), or if
# we have to split the package for DFSG purposes.  Always everything
# before the last '-'
debsrc_ver := $(shell $(pf); echo $(debian_ver) | perl -pe 's/-[^-]+$$//o')

# The flavor (i.e. emacs21) currently matches the source package name.
flavor := $(src_name)

info_subdir := emacs-$(major_ver)

######################################################################
# Customizable variables

bin_priority := 27

# This might also be something like 2006-09-09 for snapshots.
menu_ver := $(major_ver)

######################################################################

# Should these be exported like this (as autotools-dev recommends for
# the two vars below) or not?
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

# As recommended by /usr/share/doc/autotools-dev/README.Debian.gz.
# Handle cross-compiling and don't make ./configure guess.
export DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# FOR AUTOCONF 2.52 AND NEWER ONLY
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

deb_host_multiarch := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += -Wall
CFLAGS += -fno-PIE
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS += -no-pie
CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  ifneq (,$(filter $(DEB_HOST_ARCH),ia64))
    # Fix a problem with newer versions of gcc on ia64.
    # See bugs #582439 and #679986.
    CFLAGS += -O1
  endif # eq ia64
endif

joblimit := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq (,$(joblimit))
  joblimit := 1
endif

target := $(DEB_HOST_GNU_TYPE)
movemail_bin := usr/lib/emacs/$(runtime_ver)/$(target)/movemail

# Info files that are going to show up in the main dir.
main_dir_info_files := efaq.info

# Files that the build stage depends on (may also be listed in other vars).
persistent_autogen_build_files := debian/control debian/copyright
nonpersistent_autogen_build_files :=

# These files must always exist, i.e. can't ever be cleaned.
persistent_autogen_install_files :=

nonpersistent_autogen_install_files := \
  debian/$(flavor)-bin-common.lintian-overrides \
  debian/$(flavor)-bin-common.postinst \
  debian/$(flavor)-bin-common.prerm \
  debian/$(flavor)-common.README.Debian \
  debian/$(flavor)-common.docs \
  debian/$(flavor)-common.lintian-overrides \
  debian/$(flavor)-common.postinst \
  debian/$(flavor)-common.prerm \
  debian/$(flavor)-term.desktop \
  debian/$(flavor)-nox.README.Debian \
  debian/$(flavor)-nox.lintian-overrides \
  debian/$(flavor)-nox.postinst \
  debian/$(flavor)-nox.prerm \
  debian/$(flavor)-lucid.README.Debian \
  debian/$(flavor)-lucid.desktop \
  debian/$(flavor)-lucid.lintian-overrides \
  debian/$(flavor)-lucid.postinst \
  debian/$(flavor)-lucid.prerm \
  debian/$(flavor).README.Debian \
  debian/$(flavor).desktop \
  debian/$(flavor).lintian-overrides \
  debian/$(flavor).postinst \
  debian/$(flavor).prerm

autogen_build_files := \
  $(nonpersistent_autogen_build_files) $(persistent_autogen_build_files)

autogen_install_files := \
  $(nonpersistent_autogen_install_files) $(persistent_autogen_install_files)

persistent_autogen_files := \
  $(persistent_autogen_build_files) $(persistent_autogen_install_files)

nonpersistent_autogen_files := \
  $(nonpersistent_autogen_build_files) $(nonpersistent_autogen_install_files)


# Build directories
pkgdir_common := $(CURDIR)/debian/$(flavor)-common
pkgdir_bin_common := $(CURDIR)/debian/$(flavor)-bin-common
pkgdir_x := $(CURDIR)/debian/$(flavor)
pkgdir_nox := $(CURDIR)/debian/$(flavor)-nox
pkgdir_lucid := $(CURDIR)/debian/$(flavor)-lucid
pkgdir_el := $(CURDIR)/debian/$(flavor)-el

install_dir_x := $(CURDIR)/debian/install-x
install_dir_nox := $(CURDIR)/debian/install-nox
install_dir_lucid := $(CURDIR)/debian/install-lucid

local_lpath := /etc/$(flavor):/etc/emacs
local_lpath := $(local_lpath):/usr/local/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/local/share/emacs/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/$(runtime_ver)/site-lisp
local_lpath := $(local_lpath):/usr/share/emacs/site-lisp

# Installation local_lpath
local_lpath_install \
  := $(pkgdir_common)/$(subst :,:$(pkgdir_common)/,$(local_lpath))

define testdir
  dh_testdir debian/emacsVER.postinst
endef

# If we ever need to do the stripping outside of dh_strip, just add an
# INSTALL_STRIP="-s" to the make vars below.

define emacs_inst
  $(MAKE) -C debian/$(1) install \
    DESTDIR=$(2) \
    infodir=/usr/share/info/emacs-$(major_ver) \
    localstatedir=/var
endef

# If we ever need it, we can create a copy that doesn't assume ./debian/
define deb_sub
  perl -p \
